#include <config.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>

#include "parse.h"

static const unsigned char *connect_mem=NULL;
static int memsize=0;

struct state_node *states;
int num_states;

int parsefile( const char * file )
{
    int connect_fd=-1;
    struct stat filestat;
    
    connect_fd=open( file, O_RDONLY );
    fstat( connect_fd, &filestat );
    memsize=filestat.st_size;
    connect_mem=mmap(NULL, memsize, PROT_READ|PROT_WRITE, MAP_PRIVATE, connect_fd, 0);
    close(connect_fd);

    {
	const unsigned char *walk;
	int i;
	
	/* Find out how many states we have */
	num_states=0;
	for( walk=connect_mem; walk<connect_mem+memsize; ++walk ) {
	    if( *walk=='$' ) {
		num_states++;
            }
	}

	states=malloc(sizeof( struct state_node)*num_states);
	walk=connect_mem;
	for( i=0; i<num_states; ++i ) {
	    states[i].data=walk;
	    /* Find the end of the current direction */
	    while( *(walk++)!='$' )
		;
            
            // *walk='\0';
            states[i].length=walk-states[i].data-1;
            /* Find the end of the options block */
            while( walk<connect_mem+memsize && *(walk++)!='\n' )
                ;
	}
    }

    return 0;
}

/* Implement binbin in the naive way. Will be rewritten in some unspecified future date
 * binbin is the binary equivalent of strstr. It searches for needle in the haystack.
 */
const unsigned char *binbin( const unsigned char *haystack, size_t haystack_size,
	const unsigned char *needle, size_t needle_length )
{
    for( ; haystack_size>=needle_length; haystack++, haystack_size-- ) {
	int i=0;

	for( i=0; i<needle_length && haystack[i]==needle[i]; ++i )
	    ;
	
	if( i==needle_length )
	    return haystack;
    }

    return NULL;
}
